
// This file was automatically created by objectify.
// Do not edit.

#include "test.h"

extern "C" int Obj_ConfigureWidget(Tcl_Interp *interp, Tk_ConfigSpec *specs,
                     int argc, char **argv, char *widgRec, int flags);
extern "C" int Obj_ConfigureInfo(Tcl_Interp *interp, Tk_ConfigSpec *specs,
                     char *widgRec, char *argvName, int flags);

static Tcl_CmdProc FooCmd;
static Tcl_CmdProc BarCmd;
static Tcl_CmdProc ParentCmd;
static Tcl_CmdProc ChildCmd;

void
init_test(Tcl_Interp* interp, ClientData cld)
{
    Tcl_CreateCommand(interp, "foo",  FooCmd, cld, NULL);
    Tcl_CreateCommand(interp, "bar",  BarCmd, cld, NULL);
    Tcl_CreateCommand(interp, "parent",  ParentCmd, cld, NULL);
    Tcl_CreateCommand(interp, "child",  ChildCmd, cld, NULL);
}

static Tk_ConfigSpec Foo_ConfigSpecs[] = {
    { TK_CONFIG_INT, "-i", "i", "I",
      "17", Tk_Offset(Foo, i), 0, NULL },
    { TK_CONFIG_DOUBLE, "-f", "f", "F",
      "13.31", Tk_Offset(Foo, f), 0, NULL },
    { TK_CONFIG_END, NULL, NULL, NULL, NULL, 0, 0 }
};

static Tcl_CmdProc FooObjectCmd;
static int Foo_ConfigFunction(Tcl_Interp* interp,
       Tk_Window win, int ac, char** av, Foo* object,
	     int flags, int which);

static void
FooDeleteProc(ClientData cld)
{
    Foo* ob = (Foo *) cld;
    delete ob;
}

static int
FooCmd(ClientData cld, Tcl_Interp *interp, int ac, char **av)
{
    Foo* ob = new Foo (interp);

    if (Foo_ConfigFunction(interp, NULL,
                      ac - 1, av + 1, ob, 0, 1) != TCL_OK) {
        return (TCL_ERROR);
    }

    char buf[64];
    sprintf(buf, "foo_%x", (int) ob);
    Tcl_AppendResult(interp, buf, 0);
    Tcl_CreateCommand(interp, buf, FooObjectCmd, (ClientData) ob, FooDeleteProc);
    return (TCL_OK);
}

static int
FooObjectCmd(ClientData cld, Tcl_Interp *interp, int ac, char **av)
{
    Foo *ob = (Foo *) cld;
    if (ac < 2) {
        Tcl_AppendResult(interp, "too few arguments to the ",
                         av[0], " object command", 0);
        return (TCL_ERROR);
    }
    int ret = TCL_OK;
    extern int Foo_TryObjectCmd(Foo*,
             Tcl_Interp*, int, char**, int*);
    if (Foo_TryObjectCmd(ob, interp, ac, av, &ret))
        return (ret);
    Tcl_AppendResult(interp, "invalid method name \"",
                 av[1], "\"; must be one of: printall echo", 0);
    return (TCL_ERROR);
}

int
Foo_TryObjectCmd(Foo *ob, Tcl_Interp *interp,
            int ac, char **av, int* retp)
{
    char* com = av[1];
    char c = com[0];
    int length = strlen(com);
    if ((c == 'c') && !strcmp(com, "configure")) {
        *retp = Foo_ConfigFunction(interp, NULL, ac-2, av+2,
			        ob, TK_CONFIG_ARGV_ONLY, 0);
        return (1);
    }
    if ((c == 'g') && !strcmp(com, "get")) {
        static int Foo_GetFunction(Tcl_Interp* interp,
                            Tk_Window tkwin, char* name, Foo* ob);
        *retp = Foo_GetFunction(interp, NULL, av[2], ob);
        return (1);
    }
    if ((c == 'd') && !strcmp(com, "delete")) {
        if (ob->BeforeDelete(interp) != TCL_OK) { *retp = TCL_ERROR; return (1); }
        char buf[64];
        sprintf(buf, "foo_%x", (int) ob);
        Tcl_DeleteCommand(interp, buf);
        return (1);
    }
    if ((c == 'h') && !strcmp(com, "help")) {
        static void FooAppendHelp(Tcl_Interp* interp, char* what);
        if (ac < 3) {
            FooAppendHelp(interp, "summary");
        } else {
            for (int i = 2; i < ac; i++) {
                FooAppendHelp(interp, av[i]);
                if (i < ac - 1) Tcl_AppendResult(interp, "\n", 0);
            }
        }
        return (1);
    }
    if ((c == 'p') &&
        !strcmp(com, "printall")) {
        if (ac > 2) {
            Tcl_AppendResult(interp,
                         "too many arguments to ",
                         "printall: 0 maximum", 0);
           *retp = TCL_ERROR; return (1);
        }
        *retp = ob->PrintAllCmd (interp, ac - 2, av + 2);
        return (1);
    }
    if ((c == 'e') &&
        !strcmp(com, "echo")) {
        *retp = ob->EchoCmd (interp, ac - 2, av + 2);
        return (1);
    }
    return (0);
}

static void
FooAppendHelp(Tcl_Interp* interp, char* what)
{
    int all = !strcmp(what, "all");
    int one = 0;

    if (all || !strcmp(what, "summary")) {
        Tcl_AppendResult(interp, "Command: foo\n    This is a foo object.  It has no particular value in life.\n\n    Methods are: printall echo\n    Slots are: -i -f", 0);
        if (all) Tcl_AppendResult(interp, "\n\n", 0);
        one++;
    }
    if (!strcmp(what, "methods")) {
        Tcl_AppendResult(interp, "Methods are: printall echo", 0);
        one++;
    }
    if (!strcmp(what, "slots")) {
        Tcl_AppendResult(interp, "Slots are: -i -f", 0);
        one++;
    }
    if (all || !strcmp(what, "printall")) {
        Tcl_AppendResult(interp, "        printall \n                Print some useful things", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "echo")) {
        Tcl_AppendResult(interp, "        echo word ...\n                Print arguments", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "-i")) {
        Tcl_AppendResult(interp, "        -i <number> (default 17)\n                A random integer value", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "-f")) {
        Tcl_AppendResult(interp, "        -f <float value> (default 13.31)\n                A random floating-point value", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (!one)
        Tcl_AppendResult(interp, "No information is available on \"", what, "\".
Try \"help\" for a list of sub-topics.", 0);
}

int
Foo_GetSubFunc(Tcl_Interp* interp, Tk_Window win,
	        char* name, Foo* object, int* got)
{
    if (Objectify_Get(interp, win, Foo_ConfigSpecs,
			    name, (char *) object, got) != TCL_OK)
        return (TCL_ERROR);
    if (*got) return (TCL_OK);

    return (TCL_OK);
}

static int
Foo_GetFunction(Tcl_Interp* interp, Tk_Window win,
             char* name, Foo* object)
{
    int got = 0;
    int res = Foo_GetSubFunc(interp, win, name, object, &got);

    if (!got) {
        Tcl_AppendResult(interp, "unknown option \"",
                         name, "\"", 0);
	       res = TCL_ERROR;
    }
    return (res);
}

int
Foo_ConfigSubFunc(Tcl_Interp* interp, Tk_Window win,
	        int ac, char** av, Foo* object,
          int flags, int* eaten, int which)
{
    if (Objectify_Configure(interp, win, Foo_ConfigSpecs,
			    ac, av, (char *) object, flags,
			    eaten, which) != TCL_OK)
        return (TCL_ERROR);

    return (TCL_OK);
}

static int
Foo_ConfigFunction(Tcl_Interp* interp, Tk_Window win,
             int ac, char** av, Foo* object, int flags,
             int which)
{
    int nopts = ((ac > 1) ? (ac / 2) : 1);
    int* eaten = new int[nopts];
    for (int i = 0; i < nopts; i++) eaten[i] = 0;
    int res = Foo_ConfigSubFunc(interp, win, ac, av,
					  object, flags, eaten, which);

    if (ac && (res == TCL_OK)) {
        for (int i = 0; i < nopts; i++)
            if (!eaten[i]) {
	              if (res == TCL_OK) Tcl_ResetResult(interp);
	              Tcl_AppendResult(interp, "unknown option \"",
			           av[2 * i], "\"", 0);
	               res = TCL_ERROR;
	          }
    }
    delete eaten;
    if (res != TCL_OK) return (res);

    if ((ac > 1) &&(object->AfterConfigure(interp) != TCL_OK)) {
        return (TCL_ERROR);
    }
    
    return (TCL_OK);
}


// ----------------------------------------------------

static Tk_ConfigSpec Bar_ConfigSpecs[] = {
    { TK_CONFIG_RELIEF, "-relief", "relief", "Relief",
      "flat", Tk_Offset(Bar, relief), 0, NULL },
    { TK_CONFIG_ACTIVE_CURSOR, "-cursor", "cursor", "Cursor",
      NULL, Tk_Offset(Bar, cursor), TK_CONFIG_NULL_OK, NULL },
    { TK_CONFIG_BORDER, "-bg", "bg", "Bg",
      "black", Tk_Offset(Bar, bgBorder), 0, NULL },
    { TK_CONFIG_COLOR, NULL, NULL, NULL,
      NULL, Tk_Offset(Bar, bgColor), 0, NULL },
    { TK_CONFIG_PIXELS, "-bw", "bw", "Bw",
      "0", Tk_Offset(Bar, borderwidth), 0, NULL },
    { TK_CONFIG_PIXELS, "-height", "height", "Height",
      "100", Tk_Offset(Bar, height), 0, NULL },
    { TK_CONFIG_PIXELS, "-width", "width", "Width",
      "100", Tk_Offset(Bar, width), 0, NULL },
    { TK_CONFIG_END, NULL, NULL, NULL, NULL, 0, 0 }
};

static Tcl_CmdProc BarObjectCmd;
static int Bar_ConfigFunction(Tcl_Interp* interp,
       Tk_Window win, int ac, char** av, Bar* object,
	     int flags, int which);

static void
BarDeleteProc(ClientData cld)
{
    Bar* ob = (Bar *) cld;
    delete ob;
}

static int
BarCmd(ClientData cld, Tcl_Interp *interp, int ac, char **av)
{
    Tk_Window owin = (Tk_Window) cld;
    if (ac < 2) {
        Tcl_AppendResult(interp, "too few arguments: a window name is required", 0);
        return (TCL_ERROR);
    }
    Tk_Window tkwin = Tk_CreateWindowFromPath(interp, owin,
                                             av[1], NULL);
    Bar* ob = new Bar (interp, tkwin);

    if (Bar_ConfigFunction(interp, owin,
                      ac - 2, av + 2, ob, 0, 1) != TCL_OK) {
        Tk_DestroyWindow(tkwin);
        return (TCL_ERROR);
    }

    Tcl_AppendResult(interp, Tk_PathName(tkwin), 0);
    Tcl_CreateCommand(interp, Tk_PathName(tkwin), BarObjectCmd, (ClientData) ob, BarDeleteProc);
    return (TCL_OK);
}

static int
BarObjectCmd(ClientData cld, Tcl_Interp *interp, int ac, char **av)
{
    Bar *ob = (Bar *) cld;
    if (ac < 2) {
        Tcl_AppendResult(interp, "too few arguments to the ",
                         av[0], " object command", 0);
        return (TCL_ERROR);
    }
    int ret = TCL_OK;
    extern int Bar_TryObjectCmd(Bar*,
             Tcl_Interp*, int, char**, int*);
    if (Bar_TryObjectCmd(ob, interp, ac, av, &ret))
        return (ret);
    Tcl_AppendResult(interp, "invalid method name \"",
                 av[1], "\"; must be one of: ", 0);
    return (TCL_ERROR);
}

int
Bar_TryObjectCmd(Bar *ob, Tcl_Interp *interp,
            int ac, char **av, int* retp)
{
    char* com = av[1];
    char c = com[0];
    int length = strlen(com);
    if ((c == 'c') && !strcmp(com, "configure")) {
        *retp = Bar_ConfigFunction(interp, ob->tkwin, ac-2, av+2,
			        ob, TK_CONFIG_ARGV_ONLY, 0);
        return (1);
    }
    if ((c == 'g') && !strcmp(com, "get")) {
        static int Bar_GetFunction(Tcl_Interp* interp,
                            Tk_Window tkwin, char* name, Bar* ob);
        *retp = Bar_GetFunction(interp, ob->tkwin, av[2], ob);
        return (1);
    }
    if ((c == 'd') && !strcmp(com, "delete")) {
        if (ob->BeforeDelete(interp) != TCL_OK) { *retp = TCL_ERROR; return (1); }
        Tcl_DeleteCommand(interp, Tk_PathName(ob->tkwin));
        Tk_DestroyWindow(ob->tkwin);
        return (1);
    }
    if ((c == 'h') && !strcmp(com, "help")) {
        static void BarAppendHelp(Tcl_Interp* interp, char* what);
        if (ac < 3) {
            BarAppendHelp(interp, "summary");
        } else {
            for (int i = 2; i < ac; i++) {
                BarAppendHelp(interp, av[i]);
                if (i < ac - 1) Tcl_AppendResult(interp, "\n", 0);
            }
        }
        return (1);
    }
    return (0);
}

static void
BarAppendHelp(Tcl_Interp* interp, char* what)
{
    int all = !strcmp(what, "all");
    int one = 0;

    if (all || !strcmp(what, "summary")) {
        Tcl_AppendResult(interp, "Command: bar\n    This is a bar widget\n\n    Methods are: \n    Slots are: -bg -bw -height -width -relief -cursor", 0);
        if (all) Tcl_AppendResult(interp, "\n\n", 0);
        one++;
    }
    if (!strcmp(what, "methods")) {
        Tcl_AppendResult(interp, "Methods are: ", 0);
        one++;
    }
    if (!strcmp(what, "slots")) {
        Tcl_AppendResult(interp, "Slots are: -bg -bw -height -width -relief -cursor", 0);
        one++;
    }
    if (all || !strcmp(what, "-bg")) {
        Tcl_AppendResult(interp, "        -bg <color> (default black)\n                Color of the border", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "-bw")) {
        Tcl_AppendResult(interp, "        -bw <pixels> (default 0)\n                Width of the border", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "-height")) {
        Tcl_AppendResult(interp, "        -height <pixels> (default 100)\n                Height of the window", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "-width")) {
        Tcl_AppendResult(interp, "        -width <pixels> (default 100)\n                Width of the window", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "-relief")) {
        Tcl_AppendResult(interp, "        -relief <relief-value> (default flat)\n                The relief to use for the object", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "-cursor")) {
        Tcl_AppendResult(interp, "        -cursor <cursor spec> (default NULL)\n                Cursor to use in the window", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (!one)
        Tcl_AppendResult(interp, "No information is available on \"", what, "\".
Try \"help\" for a list of sub-topics.", 0);
}

int
Bar_GetSubFunc(Tcl_Interp* interp, Tk_Window win,
	        char* name, Bar* object, int* got)
{
    if (Objectify_Get(interp, win, Bar_ConfigSpecs,
			    name, (char *) object, got) != TCL_OK)
        return (TCL_ERROR);
    if (*got) return (TCL_OK);

    return (TCL_OK);
}

static int
Bar_GetFunction(Tcl_Interp* interp, Tk_Window win,
             char* name, Bar* object)
{
    int got = 0;
    int res = Bar_GetSubFunc(interp, win, name, object, &got);

    if (!got) {
        Tcl_AppendResult(interp, "unknown option \"",
                         name, "\"", 0);
	       res = TCL_ERROR;
    }
    return (res);
}

int
Bar_ConfigSubFunc(Tcl_Interp* interp, Tk_Window win,
	        int ac, char** av, Bar* object,
          int flags, int* eaten, int which)
{
    if (Objectify_Configure(interp, win, Bar_ConfigSpecs,
			    ac, av, (char *) object, flags,
			    eaten, which) != TCL_OK)
        return (TCL_ERROR);

    return (TCL_OK);
}

static int
Bar_ConfigFunction(Tcl_Interp* interp, Tk_Window win,
             int ac, char** av, Bar* object, int flags,
             int which)
{
    int nopts = ((ac > 1) ? (ac / 2) : 1);
    int* eaten = new int[nopts];
    for (int i = 0; i < nopts; i++) eaten[i] = 0;
    int res = Bar_ConfigSubFunc(interp, win, ac, av,
					  object, flags, eaten, which);

    if (ac && (res == TCL_OK)) {
        for (int i = 0; i < nopts; i++)
            if (!eaten[i]) {
	              if (res == TCL_OK) Tcl_ResetResult(interp);
	              Tcl_AppendResult(interp, "unknown option \"",
			           av[2 * i], "\"", 0);
	               res = TCL_ERROR;
	          }
    }
    delete eaten;
    if (res != TCL_OK) return (res);

    if ((ac > 1) &&(object->AfterConfigure(interp) != TCL_OK)) {
        if (object->tkwin && !flags) Tk_DestroyWindow(object->tkwin);
        return (TCL_ERROR);
    }
    
    return (TCL_OK);
}


// ----------------------------------------------------

static Tk_ConfigSpec Parent_ConfigSpecs[] = {
    { TK_CONFIG_INT, "-p", "p", "P",
      "17", Tk_Offset(Parent, p), 0, NULL },
    { TK_CONFIG_END, NULL, NULL, NULL, NULL, 0, 0 }
};

static Tcl_CmdProc ParentObjectCmd;
static int Parent_ConfigFunction(Tcl_Interp* interp,
       Tk_Window win, int ac, char** av, Parent* object,
	     int flags, int which);

static void
ParentDeleteProc(ClientData cld)
{
    Parent* ob = (Parent *) cld;
    delete ob;
}

static int
ParentCmd(ClientData cld, Tcl_Interp *interp, int ac, char **av)
{
    Parent* ob = new Parent (interp);

    if (Parent_ConfigFunction(interp, NULL,
                      ac - 1, av + 1, ob, 0, 1) != TCL_OK) {
        return (TCL_ERROR);
    }

    char buf[64];
    sprintf(buf, "parent_%x", (int) ob);
    Tcl_AppendResult(interp, buf, 0);
    Tcl_CreateCommand(interp, buf, ParentObjectCmd, (ClientData) ob, ParentDeleteProc);
    return (TCL_OK);
}

static int
ParentObjectCmd(ClientData cld, Tcl_Interp *interp, int ac, char **av)
{
    Parent *ob = (Parent *) cld;
    if (ac < 2) {
        Tcl_AppendResult(interp, "too few arguments to the ",
                         av[0], " object command", 0);
        return (TCL_ERROR);
    }
    int ret = TCL_OK;
    extern int Parent_TryObjectCmd(Parent*,
             Tcl_Interp*, int, char**, int*);
    if (Parent_TryObjectCmd(ob, interp, ac, av, &ret))
        return (ret);
    Tcl_AppendResult(interp, "invalid method name \"",
                 av[1], "\"; must be one of: pmethod method1 method2", 0);
    return (TCL_ERROR);
}

int
Parent_TryObjectCmd(Parent *ob, Tcl_Interp *interp,
            int ac, char **av, int* retp)
{
    char* com = av[1];
    char c = com[0];
    int length = strlen(com);
    if ((c == 'c') && !strcmp(com, "configure")) {
        *retp = Parent_ConfigFunction(interp, NULL, ac-2, av+2,
			        ob, TK_CONFIG_ARGV_ONLY, 0);
        return (1);
    }
    if ((c == 'g') && !strcmp(com, "get")) {
        static int Parent_GetFunction(Tcl_Interp* interp,
                            Tk_Window tkwin, char* name, Parent* ob);
        *retp = Parent_GetFunction(interp, NULL, av[2], ob);
        return (1);
    }
    if ((c == 'd') && !strcmp(com, "delete")) {
        if (ob->BeforeDelete(interp) != TCL_OK) { *retp = TCL_ERROR; return (1); }
        char buf[64];
        sprintf(buf, "parent_%x", (int) ob);
        Tcl_DeleteCommand(interp, buf);
        return (1);
    }
    if ((c == 'h') && !strcmp(com, "help")) {
        static void ParentAppendHelp(Tcl_Interp* interp, char* what);
        if (ac < 3) {
            ParentAppendHelp(interp, "summary");
        } else {
            for (int i = 2; i < ac; i++) {
                ParentAppendHelp(interp, av[i]);
                if (i < ac - 1) Tcl_AppendResult(interp, "\n", 0);
            }
        }
        return (1);
    }
    if ((c == 'p') &&
        !strcmp(com, "pmethod")) {
        if (ac > 2) {
            Tcl_AppendResult(interp,
                         "too many arguments to ",
                         "pmethod: 0 maximum", 0);
           *retp = TCL_ERROR; return (1);
        }
        *retp = ob->PmethodCmd (interp, ac - 2, av + 2);
        return (1);
    }
    if ((c == 'm') &&
        !strcmp(com, "method1")) {
        if (ac != 3 + 2) {
            Tcl_AppendResult(interp, "wrong number of args: 3 expected", 0);
            *retp = TCL_ERROR; return (1);
        }
        extern Tk_CustomOption FruitcakePtr_Option;
 Fruitcake * arg0;
 if ((*FruitcakePtr_Option.parseProc) (FruitcakePtr_Option.clientData, interp, NULL, av[2],
 (char *) &arg0, 0) != TCL_OK) { *retp = TCL_ERROR; return (1); }
        Tcl_Interp* arg1 = interp;
        int arg2;
 if (Tcl_GetInt(interp, av[3], &arg2) != TCL_OK)
 { *retp = TCL_ERROR; return (1); }
        extern Tk_CustomOption Frogs_Option;
 Frogs arg3;
 if ((*Frogs_Option.parseProc) (Frogs_Option.clientData, interp, NULL, av[4],
 (char *) &arg3, 0) != TCL_OK) { *retp = TCL_ERROR; return (1); }
        *retp = ob->Method1Cmd (arg0, arg1, arg2, arg3);
        return (1);
    }
    if ((c == 'm') &&
        !strcmp(com, "method2")) {
        if (ac != 0 + 2) {
            Tcl_AppendResult(interp, "wrong number of args: 0 expected", 0);
            *retp = TCL_ERROR; return (1);
        }
        Tcl_Interp* arg0 = interp;
        *retp = ob->Method2Cmd (arg0);
        return (1);
    }
    return (0);
}

static void
ParentAppendHelp(Tcl_Interp* interp, char* what)
{
    int all = !strcmp(what, "all");
    int one = 0;

    if (all || !strcmp(what, "summary")) {
        Tcl_AppendResult(interp, "Command: parent\n\n\n    Methods are: pmethod method1 method2\n    Slots are: -p", 0);
        if (all) Tcl_AppendResult(interp, "\n\n", 0);
        one++;
    }
    if (!strcmp(what, "methods")) {
        Tcl_AppendResult(interp, "Methods are: pmethod method1 method2", 0);
        one++;
    }
    if (!strcmp(what, "slots")) {
        Tcl_AppendResult(interp, "Slots are: -p", 0);
        one++;
    }
    if (all || !strcmp(what, "pmethod")) {
        Tcl_AppendResult(interp, "        pmethod \n", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "method1")) {
        Tcl_AppendResult(interp, "        method1 \n", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "method2")) {
        Tcl_AppendResult(interp, "        method2 \n", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "-p")) {
        Tcl_AppendResult(interp, "        -p <> (default 17)\n", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (!one)
        Tcl_AppendResult(interp, "No information is available on \"", what, "\".
Try \"help\" for a list of sub-topics.", 0);
}

int
Parent_GetSubFunc(Tcl_Interp* interp, Tk_Window win,
	        char* name, Parent* object, int* got)
{
    if (Objectify_Get(interp, win, Parent_ConfigSpecs,
			    name, (char *) object, got) != TCL_OK)
        return (TCL_ERROR);
    if (*got) return (TCL_OK);

    return (TCL_OK);
}

static int
Parent_GetFunction(Tcl_Interp* interp, Tk_Window win,
             char* name, Parent* object)
{
    int got = 0;
    int res = Parent_GetSubFunc(interp, win, name, object, &got);

    if (!got) {
        Tcl_AppendResult(interp, "unknown option \"",
                         name, "\"", 0);
	       res = TCL_ERROR;
    }
    return (res);
}

int
Parent_ConfigSubFunc(Tcl_Interp* interp, Tk_Window win,
	        int ac, char** av, Parent* object,
          int flags, int* eaten, int which)
{
    if (Objectify_Configure(interp, win, Parent_ConfigSpecs,
			    ac, av, (char *) object, flags,
			    eaten, which) != TCL_OK)
        return (TCL_ERROR);

    return (TCL_OK);
}

static int
Parent_ConfigFunction(Tcl_Interp* interp, Tk_Window win,
             int ac, char** av, Parent* object, int flags,
             int which)
{
    int nopts = ((ac > 1) ? (ac / 2) : 1);
    int* eaten = new int[nopts];
    for (int i = 0; i < nopts; i++) eaten[i] = 0;
    int res = Parent_ConfigSubFunc(interp, win, ac, av,
					  object, flags, eaten, which);

    if (ac && (res == TCL_OK)) {
        for (int i = 0; i < nopts; i++)
            if (!eaten[i]) {
	              if (res == TCL_OK) Tcl_ResetResult(interp);
	              Tcl_AppendResult(interp, "unknown option \"",
			           av[2 * i], "\"", 0);
	               res = TCL_ERROR;
	          }
    }
    delete eaten;
    if (res != TCL_OK) return (res);

    if ((ac > 1) &&(object->AfterConfigure(interp) != TCL_OK)) {
        return (TCL_ERROR);
    }
    
    return (TCL_OK);
}


// ----------------------------------------------------

static Tk_ConfigSpec Child_ConfigSpecs[] = {
    { TK_CONFIG_INT, "-c", "c", "C",
      "13", Tk_Offset(Child, c), 0, NULL },
    { TK_CONFIG_END, NULL, NULL, NULL, NULL, 0, 0 }
};

static Tcl_CmdProc ChildObjectCmd;
static int Child_ConfigFunction(Tcl_Interp* interp,
       Tk_Window win, int ac, char** av, Child* object,
	     int flags, int which);

static void
ChildDeleteProc(ClientData cld)
{
    Child* ob = (Child *) cld;
    delete ob;
}

static int
ChildCmd(ClientData cld, Tcl_Interp *interp, int ac, char **av)
{
    Child* ob = new Child (interp);

    if (Child_ConfigFunction(interp, NULL,
                      ac - 1, av + 1, ob, 0, 1) != TCL_OK) {
        return (TCL_ERROR);
    }

    char buf[64];
    sprintf(buf, "child_%x", (int) ob);
    Tcl_AppendResult(interp, buf, 0);
    Tcl_CreateCommand(interp, buf, ChildObjectCmd, (ClientData) ob, ChildDeleteProc);
    return (TCL_OK);
}

static int
ChildObjectCmd(ClientData cld, Tcl_Interp *interp, int ac, char **av)
{
    Child *ob = (Child *) cld;
    if (ac < 2) {
        Tcl_AppendResult(interp, "too few arguments to the ",
                         av[0], " object command", 0);
        return (TCL_ERROR);
    }
    int ret = TCL_OK;
    extern int Child_TryObjectCmd(Child*,
             Tcl_Interp*, int, char**, int*);
    if (Child_TryObjectCmd(ob, interp, ac, av, &ret))
        return (ret);
    Tcl_AppendResult(interp, "invalid method name \"",
                 av[1], "\"; must be one of: cmethod", 0);
    Tcl_AppendResult(interp, ", or a method for one of the objects: Parent", 0);
    return (TCL_ERROR);
}

int
Child_TryObjectCmd(Child *ob, Tcl_Interp *interp,
            int ac, char **av, int* retp)
{
    char* com = av[1];
    char c = com[0];
    int length = strlen(com);
    if ((c == 'c') && !strcmp(com, "configure")) {
        *retp = Child_ConfigFunction(interp, NULL, ac-2, av+2,
			        ob, TK_CONFIG_ARGV_ONLY, 0);
        return (1);
    }
    if ((c == 'g') && !strcmp(com, "get")) {
        static int Child_GetFunction(Tcl_Interp* interp,
                            Tk_Window tkwin, char* name, Child* ob);
        *retp = Child_GetFunction(interp, NULL, av[2], ob);
        return (1);
    }
    if ((c == 'd') && !strcmp(com, "delete")) {
        if (ob->BeforeDelete(interp) != TCL_OK) { *retp = TCL_ERROR; return (1); }
        char buf[64];
        sprintf(buf, "child_%x", (int) ob);
        Tcl_DeleteCommand(interp, buf);
        return (1);
    }
    if ((c == 'h') && !strcmp(com, "help")) {
        static void ChildAppendHelp(Tcl_Interp* interp, char* what);
        if (ac < 3) {
            ChildAppendHelp(interp, "summary");
        } else {
            for (int i = 2; i < ac; i++) {
                ChildAppendHelp(interp, av[i]);
                if (i < ac - 1) Tcl_AppendResult(interp, "\n", 0);
            }
        }
        return (1);
    }
    if ((c == 'c') &&
        !strcmp(com, "cmethod")) {
        if (ac > 2) {
            Tcl_AppendResult(interp,
                         "too many arguments to ",
                         "cmethod: 0 maximum", 0);
           *retp = TCL_ERROR; return (1);
        }
        *retp = ob->CmethodCmd (interp, ac - 2, av + 2);
        return (1);
    }
    extern int Parent_TryObjectCmd(Parent*,
          Tcl_Interp*, int, char**, int*);
    if (Parent_TryObjectCmd((Parent *) ob, interp,
                                ac, av, retp))
        return (1);
    return (0);
}

static void
ChildAppendHelp(Tcl_Interp* interp, char* what)
{
    int all = !strcmp(what, "all");
    int one = 0;

    if (all || !strcmp(what, "summary")) {
        Tcl_AppendResult(interp, "Command: child\n\n\n    Methods are: cmethod\n    Slots are: -c", 0);
        if (all) Tcl_AppendResult(interp, "\n\n", 0);
        one++;
    }
    if (!strcmp(what, "methods")) {
        Tcl_AppendResult(interp, "Methods are: cmethod", 0);
        one++;
    }
    if (!strcmp(what, "slots")) {
        Tcl_AppendResult(interp, "Slots are: -c", 0);
        one++;
    }
    if (all || !strcmp(what, "cmethod")) {
        Tcl_AppendResult(interp, "        cmethod \n", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (all || !strcmp(what, "-c")) {
        Tcl_AppendResult(interp, "        -c <> (default 13)\n", 0);
        if (all) Tcl_AppendResult(interp, "\n", 0);
        one++;
    }
    if (!one)
        Tcl_AppendResult(interp, "No information is available on \"", what, "\".
Try \"help\" for a list of sub-topics.", 0);
}

int
Child_GetSubFunc(Tcl_Interp* interp, Tk_Window win,
	        char* name, Child* object, int* got)
{
    if (Objectify_Get(interp, win, Child_ConfigSpecs,
			    name, (char *) object, got) != TCL_OK)
        return (TCL_ERROR);
    if (*got) return (TCL_OK);

    extern int Parent_GetSubFunc(Tcl_Interp*,
	    Tk_Window, char*, Parent*, int*);
    if (Parent_GetSubFunc(interp, win, name,
				 (Parent *) object, got) != TCL_OK)
        return (TCL_ERROR);
    if (*got) return (TCL_OK);
   
    return (TCL_OK);
}

static int
Child_GetFunction(Tcl_Interp* interp, Tk_Window win,
             char* name, Child* object)
{
    int got = 0;
    int res = Child_GetSubFunc(interp, win, name, object, &got);

    if (!got) {
        Tcl_AppendResult(interp, "unknown option \"",
                         name, "\"", 0);
	       res = TCL_ERROR;
    }
    return (res);
}

int
Child_ConfigSubFunc(Tcl_Interp* interp, Tk_Window win,
	        int ac, char** av, Child* object,
          int flags, int* eaten, int which)
{
    if (Objectify_Configure(interp, win, Child_ConfigSpecs,
			    ac, av, (char *) object, flags,
			    eaten, which) != TCL_OK)
        return (TCL_ERROR);

    extern int Parent_ConfigSubFunc(Tcl_Interp*,
	    Tk_Window, int, char**, Parent*, int, int*, int);
    if (Parent_ConfigSubFunc(interp, win, ac, av,
				 (Parent *) object, flags,
				 eaten, which) != TCL_OK)
        return (TCL_ERROR);
   
    return (TCL_OK);
}

static int
Child_ConfigFunction(Tcl_Interp* interp, Tk_Window win,
             int ac, char** av, Child* object, int flags,
             int which)
{
    int nopts = ((ac > 1) ? (ac / 2) : 1);
    int* eaten = new int[nopts];
    for (int i = 0; i < nopts; i++) eaten[i] = 0;
    int res = Child_ConfigSubFunc(interp, win, ac, av,
					  object, flags, eaten, which);

    if (ac && (res == TCL_OK)) {
        for (int i = 0; i < nopts; i++)
            if (!eaten[i]) {
	              if (res == TCL_OK) Tcl_ResetResult(interp);
	              Tcl_AppendResult(interp, "unknown option \"",
			           av[2 * i], "\"", 0);
	               res = TCL_ERROR;
	          }
    }
    delete eaten;
    if (res != TCL_OK) return (res);

    if ((ac > 1) &&(object->AfterConfigure(interp) != TCL_OK)) {
        return (TCL_ERROR);
    }
    
    return (TCL_OK);
}

